searchNodes=[{"type":"module","title":"argparse","doc":"Command line parser, made with hierarchy of commands in mind. Parser operates with arguments and commands , organised in a hierarchy. It is possible to define multiple commands, or none. Parsing always starts with root command , named after init:get_argument(progname) . Empty command produces empty argument map: 1 &gt; parse ( &quot;&quot; , \#{ } ) . \#{ } If root level command does not contain any sub-commands, parser returns plain map of argument names to their values: 3 &gt; argparse : parse ( [ &quot;value&quot; ] , \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } ) . \#{ arg =&gt; &quot;value&quot; } This map contains all arguments matching command line passed, initialised with corresponding values. If argument is omitted, but default value is specified for it, it is added to the map. When no default value specified, and argument is not present, corresponding key is not present in the map. Missing required (field required is set to true for optional arguments, or missing for positional) arguments raises an error. When there are sub-commands, parser returns argument map, deepest matched command name, and a sub-spec passed for this command: 4 &gt; Cmd = \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } . \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } 5 &gt; argparse : parse ( [ &quot;cmd&quot; , &quot;value&quot; ] , \#{ commands =&gt; \#{ &quot;cmd&quot; =&gt; Cmd } } ) . { \#{ arg =&gt; &quot;value&quot; } , { &quot;cmd&quot; , \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } } }","ref":"argparse.html"},{"type":"function","title":"argparse.format_error/1","doc":"Format exception reasons produced by parse/2. Exception of class error with reason {argparse, Reason} is normally raised, and format_error accepts only the Reason part, leaving other exceptions that do not belong to argparse out.","ref":"argparse.html#format_error/1"},{"type":"function","title":"argparse.format_error/3","doc":"Formats exception, and adds command usage information for command that was known/parsed when exception was raised.","ref":"argparse.html#format_error/3"},{"type":"function","title":"argparse.help/1","doc":"Equivalent to help(Command, \#{}) .","ref":"argparse.html#help/1"},{"type":"function","title":"argparse.help/2","doc":"Returns help for Command formatted according to Options specified","ref":"argparse.html#help/2"},{"type":"function","title":"argparse.parse/2","doc":"Equivalent to parse(Args, Command, \#{}) .","ref":"argparse.html#parse/2"},{"type":"function","title":"argparse.parse/3","doc":"Parses supplied arguments according to expected command definition.","ref":"argparse.html#parse/3"},{"type":"function","title":"argparse.validate/1","doc":"Equivalent to validate(Command, \#{}) . Built-in types include basic validation abilities String and binary validation may use regex match (ignoring captured value). For float, int, string, binary and atom type, it is possible to specify available choices instead of regex/min/max.","ref":"argparse.html#validate/1"},{"type":"function","title":"argparse.validate/2","doc":"Validate command specification, taking Options into account. Generates error signal when command specification is invalid.","ref":"argparse.html#validate/2"},{"type":"type","title":"argparse.arg_map/0","doc":"Arguments map: argument name to a term, produced by parser. Supplied to command handler","ref":"argparse.html#t:arg_map/0"},{"type":"type","title":"argparse.arg_type/0","doc":"","ref":"argparse.html#t:arg_type/0"},{"type":"type","title":"argparse.argparse_reason/0","doc":"","ref":"argparse.html#t:argparse_reason/0"},{"type":"type","title":"argparse.argument/0","doc":"","ref":"argparse.html#t:argument/0"},{"type":"type","title":"argparse.argument_help/0","doc":"","ref":"argparse.html#t:argument_help/0"},{"type":"type","title":"argparse.cmd_path/0","doc":"Command path, for deeply nested sub-commands","ref":"argparse.html#t:cmd_path/0"},{"type":"type","title":"argparse.command/0","doc":"","ref":"argparse.html#t:command/0"},{"type":"type","title":"argparse.command_map/0","doc":"Sub-commands are arranged into maps (cannot start with prefix )","ref":"argparse.html#t:command_map/0"},{"type":"type","title":"argparse.command_spec/0","doc":"Command name with command spec","ref":"argparse.html#t:command_spec/0"},{"type":"type","title":"argparse.handler/0","doc":"","ref":"argparse.html#t:handler/0"},{"type":"type","title":"argparse.parse_result/0","doc":"Result returned from parse/2,3: can be only argument map, or argument map with command_spec.","ref":"argparse.html#t:parse_result/0"},{"type":"type","title":"argparse.parser_options/0","doc":"","ref":"argparse.html#t:parser_options/0"},{"type":"behaviour","title":"cli","doc":"Command line utility behaviour. Usage example: From an escript main/1 function (requires -mode(compile) ): cli : run ( Args ) . Or, to limit cli behaviour discovery, cli : run ( Args , \#{ modules =&gt; ? MODULE , progname =&gt; ? MODULE } ) . Other options available for run/2: modules : all_loaded - search all loaded modules ( code:all_loaded/0 ) for cli behaviour module() - use this module (must export cli/0 ) [module()] - list of modules (must export cli/0 ) warn : set to suppress suppresses warnings logged error : defines what action is taken upon parser error. Use ok to completely ignore the error (historical behaviour, useful for testing), error to raise an exception, halt to halt the emulator with exit code 1 (default behaviour), and {halt, non_neg_integer()} for a custom exit code halting the emulator help : set to false suppresses printing usage when parser produces an error, and disables default --help/-h behaviour prefixes : prefixes passed to argparse progname : specifies executable name instead of 'erl' Warnings are printed to OTP logger, unless suppressed. cli framework attempts to create a handler for each command exported, including intermediate (non-leaf) commands, if it can find function exported with suitable signature. cli examples are available on GitHub","ref":"cli.html"},{"type":"callback","title":"cli.cli/0","doc":"","ref":"cli.html#c:cli/0"},{"type":"function","title":"cli.run/1","doc":"Equivalent to run(Args, \#{}) .","ref":"cli.html#run/1"},{"type":"function","title":"cli.run/2","doc":"CLI entry point, parses arguments and executes selected function. Finds all modules loaded, and implementing cli behaviour, then matches a command and runs handler defined for a command.","ref":"cli.html#run/2"},{"type":"type","title":"cli.run_options/0","doc":"","ref":"cli.html#t:run_options/0"},{"type":"extras","title":"Overview","doc":"A mini-framework to create complex cli. Inspired by Python argparse. Follows conventions of Unix Utility Argument Syntax. argparse [-abcDxyz][-p arg][operand]","ref":"readme.html"},{"type":"extras","title":"Overview - Argument parser","doc":"Converts list of strings (command line) into an argument map,and a command path; see argparse reference for detailed description.","ref":"readme.html#argument-parser"},{"type":"extras","title":"Overview - cli mini-framework","doc":"Make a step beyond parser, and export existing Erlang functions: cli reference","ref":"readme.html#cli-mini-framework"},{"type":"extras","title":"Overview - Basic example","doc":"cli is naturally suitable for building small escript-based apps: # ! / usr / bin / env escript - export ( [ main / 1 , cli / 0 , rm / 1 ] ) . - behaviour ( cli ) . - mode ( compile ) . %% evaluated module cannot contain callbacks main ( Args ) -&gt; cli : run ( Args , \#{ progname =&gt; &quot;simple&quot; } ) . cli ( ) -&gt; \#{ handler =&gt; { ? MODULE , rm } , arguments =&gt; [ \#{ name =&gt; force , short =&gt; $f , type =&gt; boolean , default =&gt; false } , \#{ name =&gt; recursive , short =&gt; $r , type =&gt; boolean , default =&gt; false } , \#{ name =&gt; dir } ] } . rm ( \#{ force := Force , recursive := Recursive , dir := Dir } ) -&gt; io : format ( &quot;Removing ~s (force ~s , recursive: ~s ) ~n &quot; , [ Dir , Force , Recursive ] ) . The example above does not have sub-commands, and implements rm/1 handler, that serves as an entry point with parsed arguments. Help options are added automatically: $ ./erm --help usage: erm [-fr] &lt;dir&gt; Optional arguments: dir -r recursive, [false] -f force, [false]","ref":"readme.html#basic-example"},{"type":"extras","title":"Overview - Calc: cli with multiple commands","doc":"Calculator implements several commands, with sub-commands available. Full source code here: doc/examples/escript/calc Command definitions: cli ( ) -&gt; \#{ commands =&gt; \#{ &quot;sum&quot; =&gt; \#{ arguments =&gt; [ \#{ name =&gt; num , nargs =&gt; nonempty_list , type =&gt; int , help =&gt; &quot;Numbers to sum&quot; } ] } , &quot;math&quot; =&gt; \#{ commands =&gt; \#{ &quot;sin&quot; =&gt; \#{ handler =&gt; { math , sin , undefined } } , &quot;cos&quot; =&gt; \#{ } , &quot;tan&quot; =&gt; \#{ handler =&gt; { math , tan , undefined } } } , arguments =&gt; [ \#{ name =&gt; in , type =&gt; float , help =&gt; &quot;Input value&quot; } ] } , &quot;mul&quot; =&gt; \#{ arguments =&gt; [ \#{ name =&gt; left , type =&gt; int } , \#{ name =&gt; right , type =&gt; int } ] } } } . The calculator provides &quot;sum&quot; command that prints a sum of integer numbers: $ ./calc sum 1 2 3 6 Math sub-commands provide trigonometric functions: $ ./calc math cos 1.4 0.16996714290024104 $ ./calc math sin 1.4 0.9854497299884601","ref":"readme.html#calc-cli-with-multiple-commands"},{"type":"extras","title":"Overview - Complex applications","doc":"cli is capable of handling releases containing hundreds of modules implementing cli behaviour. Commands may be exported from multiple modules and applications. cli makes best efforts to merge commands exported, format usage output and error messages. See example: doc/examples/multi This example contains two modules, multi_math.erl and multi_string.erl. Use rebar3 escriptize to build the application. Try various commands, e.g. ./multi math cos 1.0 , or ./multi string lexemes 1+2+3+4 -s + to get a feeling!","ref":"readme.html#complex-applications"},{"type":"extras","title":"Overview - Argument parser alone","doc":"It is possible to use argument parser alone, without the cli mini-framework: # ! / usr / bin / env escript main ( Args ) -&gt; \#{ force := Force , recursive := Recursive , dir := Dir } = argparse : parse ( Args , cli ( ) ) , io : format ( &quot;Removing ~s (force: ~s , recursive: ~s ) ~n &quot; , [ Dir , Force , Recursive ] ) . cli ( ) -&gt; \#{ arguments =&gt; [ \#{ name =&gt; force , short =&gt; $f , type =&gt; boolean , default =&gt; false } , \#{ name =&gt; recursive , short =&gt; $r , type =&gt; boolean , default =&gt; false } , \#{ name =&gt; dir } ] } .","ref":"readme.html#argument-parser-alone"},{"type":"extras","title":"Overview - Help and usage information","doc":"cli automatically prints usage, if command line parser reports an error. An attempt is made to guess the most relevant command. Argument help can be customised.","ref":"readme.html#help-and-usage-information"},{"type":"extras","title":"Overview - Build","doc":"This project requires OTP-22 or above. Simple integration is available via Hex and rebar3. { deps , [ argparse ] } .","ref":"readme.html#build"},{"type":"extras","title":"Overview - Known incompatibilities","doc":"In comparison with Python implementation, argparse for Erlang: boolean flag (option) automatically uses {store, true} all positional arguments are required by default (even when nargs is 'maybe') first-class (sub) commands, slightly differently from argparse implicit --help/-h is not a part of argparse (but implemented in cli) Commands vs. positional arguments: command always takes precedence over a positional argument. Commands form exclusive groups, e.g. only one command can be followed at a time.","ref":"readme.html#known-incompatibilities"},{"type":"extras","title":"Overview - Supported command line syntax","doc":"command (priority positional argument) : ectl {crawler|reader|writer} command, and sub-command: ectl crawler {start|stop|check} positional argument (required): ectl &lt;arg1&gt; &lt;arg2&gt; positional argument (with default): ectl [&lt;arg1&gt;] boolean flag: ectl [-rf] required flag: ectl -r short optional argument: ectl [-i &lt;int&gt;] short optional: ectl [-i [&lt;int&gt;]] required short option: ectl -i &lt;int&gt; long option flag: ectl [--foo] long optional argument: ectl [--foo &lt;arg&gt;] required long: ectl --foo &lt;arg&gt; long, arg=value form: ectl --foo=arg list of arguments: ectl &lt;arg&gt;, ...","ref":"readme.html#supported-command-line-syntax"},{"type":"extras","title":"Overview - Expected features","doc":"To be considered after 1.2.0: search for commands and arguments (mini-man) abbreviated long forms mutual exclusion groups shell auto-complete automatically generated negative boolean long forms &quot;--no-XXXX&quot;","ref":"readme.html#expected-features"},{"type":"extras","title":"CLI API","doc":"cli is designed to simplify command-line interface integration. From a tiny escript, to a system exporting several hundred commands.","ref":"cli_ref.html"},{"type":"extras","title":"CLI API - Basic example","doc":"Ensure argparse is in your code path when running examples. cd doc/examples/escript ERL_FLAGS=&quot;-pa ../../../_build/default/lib/argparse/ebin&quot; ./calc mul 2 2 Implementing a utility with a single command to run requires: Compiled code (as evaluated code does not work with callbacks) 'cli' behaviour declared cli/0 callback returning arguments map and a handler #!/usr/bin/env escript -export([main/1, cli/0, cli/1]). -behaviour(cli). -mode(compile). %% evaluated module cannot contain callbacks main(Args) -&gt; cli : run ( Args , \#{ progname =&gt; &quot;simple&quot; } ) . cli() -&gt; \#{ arguments =&gt; [ \#{ name =&gt; force , short =&gt; $f , type =&gt; boolean , default =&gt; false } , \#{ name =&gt; recursive , short =&gt; $r , type =&gt; boolean , default =&gt; false } , \#{ name =&gt; dir } ] } . cli(\#{force := Force, recursive := Recursive, dir := Dir}) -&gt; io : format ( &quot;Removing ~s (force ~s , recursive: ~s ) ~n &quot; , [ Dir , Force , Recursive ] ) .","ref":"cli_ref.html#basic-example"},{"type":"extras","title":"CLI API - rebar3 escript example","doc":"Creating a new application exposing CLI is as simple as: Running rebar3 new escript conf_reader Adding argparse to deps and escript_incl_apps in rebar.config Add a function ( cli/0 ) declaring CLI arguments Use the specification: argparse:parse(Args, cli()) Run rebar3 escriptize to build the application.","ref":"cli_ref.html#rebar3-escript-example"},{"type":"extras","title":"CLI API - Command-line interface discovery","doc":"By default, cli:run/1 scans all loaded modules to find those implementing cli behaviour. Use run/2 with modules option to specify a single module, or a list of modules to search (default is all_loaded ): cli : run ( [ &quot;arg&quot; ] , \#{ modules =&gt; ? MODULE } ) . When there are multiple modules in the list, cli merges all arguments and commands exported by these modules. In case of a conflict (e.g. clashing short or long option name, or top-level command name), first match is accepted, and all others are discarded (with warning emitted to OTP logger, can be switch off with warn flag set to false). Be careful with top-level arguments exported: they are added to all commands produced by all modules - this side effect is usually undesired. There is a warning emitted if more than one module implements cli behaviour, and global arguments are exported.","ref":"cli_ref.html#command-line-interface-discovery"},{"type":"extras","title":"CLI API - Handler specification","doc":"Handler is a callback invoked by cli:run when command line parser completes successfully. Handler may accept a single argument (map of argument names to their values, as returned by argparse): sum ( \#{ numbers := Numbers } ) -&gt; lists : sum ( Numbers ) . In this case, command spec should define handler either as fun, or as a tuple {module(), atom()} , this requires function to be exported: %% map form: cli ( ) -&gt; \#{ commands =&gt; { &quot;sum&quot; =&gt; \#{ handler =&gt; fun sum / 1 } } } . %% exported function, map form: cli ( ) -&gt; \#{ commands =&gt; { &quot;sum&quot; =&gt; \#{ handler =&gt; { ? MODULE , sum } } } } . Handler may accept positional arguments: start ( Server , Mode ) -&gt; supervisor : start_child ( my_server_sup , \#{ id =&gt; Server , start =&gt; { my_server , start_link , [ Mode ] } } ) . In this case handler specification must define default value for missing arguments: handler =&gt; { fun start / 2 , undefined } %% ... or, for exported function: handler =&gt; { ? MODULE , start , undefined }","ref":"cli_ref.html#handler-specification"},{"type":"extras","title":"CLI API - Default handler","doc":"When handler is not specified, cli generates default one, based on the module implementing cli behaviour, and default field passed to run/2 . When the field it set, positional form for handler is generated, with default set to the term supplied. cli does not check whether handler function exists or exported.","ref":"cli_ref.html#default-handler"},{"type":"extras","title":"CLI API - Help/usage information","doc":"By default, when parser encounters an error, cli generates both error message and help/usage information. It is possible to suppress usage messages by providing help option set to false . This also disables usage output for --help or -h request. As most escripts are interpreted via erl , it is recommended to define progname to provide correct help/usage line: cli : run ( [ &quot;arg&quot; ] , \#{ progname =&gt; &quot;mycli&quot; } ) .","ref":"cli_ref.html#help-usage-information"},{"type":"extras","title":"CLI API - Reference","doc":"cli is able to pass prefixes option to argparse (this also changes -h and --help prefix). There are also additional options to explore, see cli:run/2 function reference. cli also passes default option to argparse.","ref":"cli_ref.html#reference"},{"type":"extras","title":"argparse API","doc":"Parser operates with arguments and commands , organised in a hierarchy. It is possible to define multiple commands, or none. Parsing always starts with root command , named after init:get_argument(progname) . Empty command produces empty argument map: 1 &gt; parse ( &quot;&quot; , \#{ } ) . \#{ }","ref":"argparse_ref.html"},{"type":"extras","title":"argparse API - Options specification","doc":"It's possible to override program name using progname option: 2 &gt; io : format ( argparse : help ( \#{ } , \#{ progname =&gt; &quot;readme&quot; } ) ) . usage : readme To override default optional argument prefix ( - ), use prefixes option: 3 &gt; argparse : parse ( [ &quot;+sbwt&quot; ] , \#{ arguments =&gt; [ \#{ name =&gt; mode , short =&gt; $s } ] } , \#{ prefixes =&gt; &quot;+&quot; } ) . \#{ mode =&gt; &quot;bwt&quot; } To define a global default for arguments that are not required, use default option: 4 &gt; argparse : parse ( [ ] , \#{ arguments =&gt; [ \#{ name =&gt; mode , required =&gt; false } ] } , \#{ default =&gt; undef } ) . \#{ mode =&gt; undef } When global default is not set, resulting argument map does not include keys for arguments that are not specified in the command line and there is no locally defined default value.","ref":"argparse_ref.html#options-specification"},{"type":"extras","title":"argparse API - Validation, help &amp; usage information","doc":"Function validate/1 may be used to validate command with all sub-commands and options without actual parsing done. 4 &gt; argparse : validate ( \#{ arguments =&gt; [ \#{ short =&gt; $4 } ] } ) . * * exception error : { argparse , { invalid_option , [ &quot;erl&quot; ] , [ ] , name , &quot;argument must be a map, and specify &#39;name&#39;&quot; } } Human-readable errors and usage information is accessible via help/2 and format_error/1,2 .","ref":"argparse_ref.html#validation-help-usage-information"},{"type":"extras","title":"argparse API - Return value","doc":"If root level command does not contain any sub-commands, parser returns plain map of argument names to their values: 3 &gt; argparse : parse ( [ &quot;value&quot; ] , \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } ) . \#{ arg =&gt; &quot;value&quot; } This map contains all arguments matching command line passed, initialised with corresponding values. If argument is omitted, but default value is specified for it, it is added to the map. When no local default value specified, and argument is not present, corresponding key is not present in the map, unless there is a global default passed with parse/3 options. Missing required (field required is set to true for optional arguments, or missing for positional) arguments raises an error. When there are sub-commands, parser returns argument map, deepest matched command name, and a sub-spec passed for this command: 4 &gt; Cmd = \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } . \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } 5 &gt; argparse : parse ( [ &quot;cmd&quot; , &quot;value&quot; ] , \#{ commands =&gt; \#{ &quot;cmd&quot; =&gt; Cmd } } ) . { \#{ arg =&gt; &quot;value&quot; } , { &quot;cmd&quot; , \#{ arguments =&gt; [ \#{ name =&gt; arg } ] } } }","ref":"argparse_ref.html#return-value"},{"type":"extras","title":"argparse API - Command specification","doc":"Command specification may contain following fields: commands - sub-commands, name to nested command spec arguments - list of argument specifications help - string to generate usage information, can be set to hidden , causing this command to be omitted in usage output handler - function expected to process this command, or optional atom user-defined fields Missing handler field is automatically populated by CLI framework, when a module exporting cli/0 also exports function function with arity 1, named after command: cli ( ) -&gt; \#{ commands =&gt; \#{ &quot;run&quot; =&gt; \#{ . . . } } } . run ( ArgMap ) -&gt; . . . . If command contains sub-commands, and handler is not present, it is an error if arguments supplied to parse do not select one of the sub-commands. Set handler to optional to not require sub-command selected. Command is matched as a positional argument, taking precedence over other positional arguments. For any positional argument found, parser will first attempt to match a sub-command in currently evaluated command. If there is no match, parser considers next argument as positional. Example: 1 &gt; Cmd = \#{ commands =&gt; \#{ sub =&gt; \#{ } } , arguments =&gt; [ \#{ name =&gt; positional } ] } , 2 &gt; parse ( [ &quot;arg&quot; , &quot;sub&quot; ] , Cmd ) == parse ( [ &quot;arg&quot; , &quot;sub&quot; ] , Cmd ) . true Command names cannot start with prefix character.","ref":"argparse_ref.html#command-specification"},{"type":"extras","title":"argparse API - Argument specification","doc":"Every argument spec must have name field. Name defines key in the parsed arguments map, similar to dest field of Python library. It is allowed to have multiple arguments with the same name (option aliases): options =&gt; [ \#{ name =&gt; foo , short =&gt; $f } , \#{ name =&gt; foo , long =&gt; &quot;-foo&quot; } , \#{ name =&gt; foo } ] . An argument can be: optional : matching command line arguments with prefix character positional : arguments not starting with a prefix Negative number is considered positional argument, when - prefix is used, and there is no no optional argument spec that has short or long form defined as number ( \#{name =&gt; one, short =&gt; $1} ). Argument is optional when short or long field is defined. Short form may only contain a single character, and long form may contain any string. A single prefix character is automatically prepended to long forms, so for this example: \#{ name =&gt; myarg , short =&gt; $m , long =&gt; &quot;-myarg&quot; } Argument myarg can be specified as -m or as --myarg . Please note that it is possible to have long forms with a single prefix character: \#{ name =&gt; kernel , long =&gt; &quot;kernel&quot; } By default, optional arguments are not required and may be omitted from command line. Positional arguments are required. It is possible to override this behaviour by setting required field. It is supported to specify long-form value using this syntax: mycli --arg=value It is treated the same way as mycli --arg value . For every argument matched, parser may consume several following positional arguments (not starting with a prefix). Analysis is based on nargs , action and type fields. when nargs is 'maybe' and next argument is positional, it gets consumed and produced as value, and if next argument starts with option prefix, default value is produced (when no default present, default value deduced from argument type ) when nargs is {'maybe', Term} , and next argument starts with option prefix, Term is produced when nargs is set to a positive integer, parser tries to consume exactly this number of positional arguments, and fails with an error if there is not enough. Produced value is a list. when nargs is set to nonempty_list , parser consumes at least one following positional argument (fails if first argument is not positional), until it finds next optional argument. Produced value is a list. when nargs is list , parser consumes positional arguments until it finds next optional. Produced value is a list. when nargs is all , all remaining arguments (whether positional or not) are folded into single produced list. When nargs is not specified, action determines how many arguments are consumed. For store/append, single argument is consumed. Special handling is done for boolean type : no argument is consumed, even for store/append. If it is necessary to consume an argument for boolean type, use type =&gt; atom with choices =&gt; [&quot;true&quot;, &quot;false&quot;] . Action can have following values: store - replace value in the argument map (last value wins) append - append value to existing list (when value is also a list, resulting value can be a list of lists) {store, Term} - do not consume argument, replace current value with Term {append, Term} - do not consume argument, append Term to list of existing values count - do not consume any arguments, bump the counter - useful for bumping logging verbosity level, e.g. cmd -vvv extend - valid only for nargs set to list/nonempty_list/all/(pos_integer()), explodes this list and appends every single value to existing list, so result is just a list, not a list of lists Arguments have type associated. Default type is string, taken unprocessed from command line input. int, {int, Limits} - where Limits is a list containing {min, Int}, {max, Int} tuples float, {float, Limits} - same as int, but for floating point string, {string, Regex}, {string, Regex, RegexOption} - string validated with Regex binary, {binary, Regex}, {binary, Regex, RegexOption} - same as string, but of binary type atom - existing atom (error when atom does not exist) {atom, unsafe} - atom, creates new atoms when needed {custom, Fun} - custom type conversion from string() into term() For int, float, string, binary and atom, it is also possible to specify list of choices that will pass validation: \#{ name =&gt; choices , short =&gt; $c , type =&gt; { string , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; ] } } Custom function may throw erlang:error(invalid_argument) , to utilise built-in validation information. If any other exception is raised, it is passed with no conversion. An error is thrown when argument cannot be converted to required type, or does not pass validation. If custom conversion function throws error(invalid_argument), exception is augmented with necessary parser state information (any other exception passes through unchanged). It is not allowed to store user-defined fields in arguments.","ref":"argparse_ref.html#argument-specification"},{"type":"extras","title":"argparse API - Errors","doc":"Argparse throws exceptions of class error, and Reason tuple: { argparse , ArgParseError } To get human-readable representation: try argparse : parse ( Args , Command ) catch error : { argparse , Reason } -&gt; io : format ( argparse : format_error ( Reason , Command , \#{ } ) ) end .","ref":"argparse_ref.html#errors"},{"type":"extras","title":"argparse API - Help templates","doc":"To completely hide the argument or command from the output, supply help =&gt; hidden . It is possible to override help text generated for arguments. By default, options are formatted with &quot;help text, type, default&quot;, e.g.: crawl [ - s &lt; shard &gt; . . . ] [ - z &lt; last &gt; ] [ - c &lt; choice &gt; ] Optional arguments : - s initial shards , int - z last shard , between , 100 &lt; int &lt; 200 , 150 - c tough choice , choice : 1 , 2 , 3 It is possible to override the description, and print it this way: crawl [ - s SHARD ] [ - c CHOICE ] Optional arguments : - s initial number , int , with a default value of 0 - z 150 , number of last shard , unless overridden - c custom parameter , to choose from 1 , 2 or 3 Example: \#{ arguments =&gt; [ \#{ name =&gt; shard , default =&gt; 0 , help =&gt; { &quot;[-s SHARD]&quot; , [ &quot;initial number, &quot; , type , &quot; with a default value of &quot; , default ] } } ] } First element of the tuple replaces [-s &lt;shard&gt;] with [-s SHARD] in command line example, and second defines detailed help template.","ref":"argparse_ref.html#help-templates"},{"type":"extras","title":"Changelog","doc":"Version 1.2.4: minor spec fixes Version 1.2.3: implemented global default minor bugfixes Version 1.2.1: minor bugfixes, support for choices of atoms Version 1.2.0: CLI incompatible change: cli:run/1,2 by default now calls halt(1) in case of a parser error bugfixes Version 1.1.3: added help =&gt; hidden for commands and options changed default formatting for better readability fixed bug causing nargs =&gt; all to be ignored Version 1.1.2: support for &quot;--arg=value&quot; form Version 1.1.1: added templates for help text Version 1.1.0: Handler support for minimal CLI cli/1 optional behaviour callback deprecated Ability to provide progname as an atom Version 1.0.2: Improved documentation Validation run for CLI commands Version 1.0.0: First public release Version 0.1.0: First usable version (API is unstable yet)","ref":"changelog.html"},{"type":"extras","title":"License","doc":"BSD 3-Clause License Copyright (c) 2020-2023, Maxim Fedorov All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"},{"type":"extras","title":"simple","doc":"#!/usr/bin/env escript %% simple cli using cli behaviour -behaviour(cli). -mode(compile). -export([cli/0, rm/3]). main(Args) -&gt; cli:run(Args, \#{progname =&gt; &quot;simple&quot;}). cli() -&gt; \#{ handler =&gt; {?MODULE, rm, undefined}, arguments =&gt; [ \#{name =&gt; force, short =&gt; $f, type =&gt; boolean, default =&gt; false}, \#{name =&gt; recursive, short =&gt; $r, type =&gt; boolean, default =&gt; false}, \#{name =&gt; dir} ] }. rm(Force, Recursive, Dir) -&gt; io:format(&quot;Removing ~s (force: ~s, recursive: ~s)~n&quot;, [Dir, Force, Recursive]).","ref":"simple.html"},{"type":"extras","title":"calculator","doc":"#!/usr/bin/env escript %% calculator, demonstrating sub-commands, and handler specifications %% how to run from: %% ERL_FLAGS=&quot;-pa ../../../_build/default/lib/argparse/ebin&quot; ./calc mul 2 2 -behaviour(cli). -mode(compile). -export([cli/0, sum/1, cos/1, mul/1]). main(Args) -&gt; Out = cli:run(Args, \#{progname =&gt; &quot;calc&quot;}), io:format(&quot;~p~n&quot;, [Out]). cli() -&gt; \#{ commands =&gt; \#{ &quot;sum&quot; =&gt; \#{ arguments =&gt; [ \#{name =&gt; num, nargs =&gt; nonempty_list, type =&gt; int, help =&gt; &quot;Numbers to sum&quot;} ] }, &quot;math&quot; =&gt; \#{ commands =&gt; \#{ &quot;sin&quot; =&gt; \#{handler =&gt; {math, sin, undefined}}, &quot;cos&quot; =&gt; \#{}, &quot;tan&quot; =&gt; \#{handler =&gt; {math, tan, undefined}} }, arguments =&gt; [ \#{name =&gt; in, type =&gt; float, help =&gt; &quot;Input value&quot;} ] }, &quot;mul&quot; =&gt; \#{ arguments =&gt; [ \#{name =&gt; left, type =&gt; int}, \#{name =&gt; right, type =&gt; int} ] } } }. sum(\#{num := Nums}) -&gt; lists:sum(Nums). cos(\#{in := In}) -&gt; math:cos(In). mul(\#{left := Left, right := Right}) -&gt; Left * Right.","ref":"calc.html"},{"type":"extras","title":"erm","doc":"#!/usr/bin/env escript %% argparse example, without cli behaviour used %% how to try: %% ERL_FLAGS=&quot;-pa ../../../_build/default/lib/argparse/ebin&quot; ./erm -rf dir main(Args) -&gt; \#{force := Force, recursive := Recursive, dir := Dir} = argparse:parse(Args, cli()), io:format(&quot;Removing ~s (force: ~s, recursive: ~s)~n&quot;, [Dir, Force, Recursive]). %% parser specification cli() -&gt; \#{arguments =&gt; [ \#{name =&gt; force, short =&gt; $f, type =&gt; boolean, default =&gt; false}, \#{name =&gt; recursive, short =&gt; $r, type =&gt; boolean, default =&gt; false}, \#{name =&gt; dir} ]}.","ref":"erm.html"}]